Redmine - Feature #3436

Show relations in Gantt diagram
2009-06-02 12:27 - Michael Diederich

Status: Closed Start date: 2009-06-02
Priority: Normal Due date:

Assignee: % Done: 80%
Category: Gantt Estimated time: 0.00 hour
Target version: 2.3.0

Resolution: Fixed

Description

Hi,

| request a feature: Please show the relations, especially the blocks and dependencies, within the gantt diagram. Attached is a
related screenshot, how | would like to see the result.

Thanks,

Michael

Related issues:

Related to Redmine - Feature #549: Indicate issue dependencies in gantt Closed
Related to Redmine - Feature #12122: Gantt progress lines (html only) Closed

Associated revisions

Revision 11118 - 2013-01-05 13:28 - Jean-Philippe Lang

Show precedes/follows and blocks/blocked relations on the Gantt diagram (#3436).

Based on Toshi MARUYAMA's patch.

Revision 11119 - 2013-01-05 13:34 - Jean-Philippe Lang
Use JSON so we don't have to parse data-rels manually (#3436).

Revision 11120 - 2013-01-05 13:41 - Jean-Philippe Lang

Only process issues that have relations.

Revision 11123 - 2013-01-05 17:04 - Jean-Philippe Lang
Adjust test for r11120 (#3436).

History

#1 - 2009-06-08 17:09 - Yohann Monnier

+1!

#2 - 2009-08-09 20:54 - Stavros Korokithakis

Even if the relationships aren't shown, it would be immensely useful if the time dependencies were. For example, if issue A blocks B, issue B should
start after A ends, not when it starts, like it is now.

#3 - 2009-10-10 10:35 - Ochir Abushinov
- Assignee set to Jean-Philippe Lang

yes, | would like to ask somebody of Redmine developers to implement this feature. My organization uses Redmine as project manager, and Gantt
chart is only thing annoying us.
Could this feature be implemented in 0.8.6 version?

#4 - 2009-10-23 10:19 - Ochir Abushinov
- Assignee deleted (Jean-Philippe Lang)
#5 - 2009-10-25 15:34 - S Reid

+1

#6 - 2009-11-10 10:28 - Ochir Abushinov

Any news?

#7 - 2009-11-18 16:07 - Ochir Abushinov
up

#8 - 2010-06-25 20:02 - Felix Faber

+1

#9 - 2010-08-11 11:30 - sebastian ovide

+1

#10 - 2010-10-03 15:13 - Mischa The Evil
- Category set to Gantt

#11 - 2010-10-14 04:55 - Paul H

+1

#12 - 2010-11-07 19:47 - Sam Kuper

+1

#13 - 2010-11-07 23:02 - Michalis Miatidis
+N (N->00)

#14 - 2010-12-07 21:34 - Kyle Plattner

+1 for me too

#15 - 2011-01-06 16:04 - Lionel TRESSENS

+1
Need funding to accelerate this enhancement ? Tell me, my company may possibly fund it.

#16 - 2011-02-24 16:15 - Mauro Gagna

+1

#17 - 2011-03-11 11:47 - Luis Serrano Aranda
Try the plugin better gantt char

#18 - 2011-03-11 13:46 - Fernando Hartmann

+1

#19 - 2012-06-08 15:50 - Alex Lazar

Are there any plans to make this work?

#20 - 2012-10-19 08:55 - Anonymous

+1

#21 - 2012-11-02 12:07 - Daniel Felix

+1 from me too

#22 - 2012-12-05 11:49 - Toshi MARUYAMA
- File gantt-relations-r10943.diff added

- File gantt-relations-r10943.png added

- % Done changed from 0 to 80
This is a patch for trunk r10943.

« Filters

o Status

» Display

open ¥

» Related issues

7 [l Related to @ [ Duplicates

IES manths from iDecember T i2012 v & Apply ‘.'g) Clear

s redmine-bb-all

=}

=

=l

Bug #42:
Bug #43:
Bug #44:
Bug #45:
Bug #46:
Bug #47:

Rails 3 support

SCM command availability automatic check in ad--
Rails 3 support

cannot browse swn repository

Confusing revisions links on repository root

Fix Lithuanian numeral translation

#23 - 2012-12-05 12:37 - Toshi MARUYAMA
- File gantt-relations-r10943-Ver2.diff added

Sorry, note-22 patch has wrong html table tag.
This patch removed it.
This patch is for trunk r10943.

#24 - 2012-12-05 14:18 - Etienne Massip

Nice work.

49

2012-12
51

50

# B EBlocks @ [ Precedes @ [ Copied ta

52

Add filter |
% Zool

2013-1
2 | 3 5 | 6

L 2

e You can use content_opt[:data] = { 'rel-blocks' => v.join(',") } in helper and $(...).data('rel-blocks')
¢ Typo landscape_mergin -> landscape_margin

Wouldn't be worth it/easier to maitain to make the whole Gantt a SVG graph?

#25 - 2012-12-10 11:04 - Toshi MARUYAMA
- File gantt-relations-r10973.diff added

Etienne Massip wrote:

Done.

And fixed JavaScript error when a issue does not have a bar (no start date or out range).

This is a patch for trunk r10973.

#26 - 2012-12-10 13:17 - Toshi MARUYAMA
- File gantt-relations-r10973-V2.diff added

| have removed unused variables from note-25 patch.

This is a patch for trunk r10973.

#27 - 2012-12-10 14:27 - Jean-Philippe Lang

- Target version set to 2.3.0

Looks sweet!
But | don't think that displaying "related to", "copied to" or "duplicates" relations is that usefull. As request initially, | think we should only display
"precedes" and "blocks" relations.

#28 - 2012-12-10 15:10 - Etienne Massip
Jean-Philippe Lang wrote:
Looks sweet!

"o

But | don't think that displaying "related to", "copied to" or "duplicates” relations is that usefull. As request initially, | think we should only display
"precedes" and "blocks" relations.

No, it should definitively not appear.

| think there should not be any possibility to select what relation types you want to show, just "precedes" and "blocks".
Not sure the foreach syntax for (rel_type_key in ...) {} is supported by IE7/8?

Finally, why not leave a permanent issue div class instead of removing a temporary todo class, which is a bit dirty?
#29 - 2012-12-20 07:43 - Toshi MARUYAMA

- File gantt-relations-r11060.png added
- File gantt-relations-r11060.diff added

This is a patch for trunk r11060.

« Display
« Related issues

4 Blocks . Precedes

® Zoomin g
G months from |DECEI‘T1bEI’ T |2C|12 K4 Apply 2 Clear

2012-12 2013-1 2013-2
49 | 50 5_‘ 52 1 2 3 - & b 7

& redmine-bb-all * redminesbt
#42: Rails 3 support
| Bug #43: 5CM command availability automatic check in a
#44: Rails 3 support
#45: cannot browse svn repository
| Bug #46: Confusing revisions links on repository root

| Bug #47: Fix Lithuanian numeral translation

| Bug #48: cannot browse svn repository
Etienne Massip wrote:
Jean-Philippe Lang wrote:
Looks sweet!

But | don't think that displaying "related to", "copied to" or "duplicates" relations is that usefull. As request initially, | think we should only
display "precedes" and "blocks" relations.

No, it should definitively not appear.
| think there should not be any possibility to select what relation types you want to show, just "precedes" and "blocks".

Done.

Not sure the foreach syntax for (rel_type_key in ...) {} is supported by IE7/8?

Sorry, | have not tested yet.

Finally, why not leave a permanent issue div class instead of removing a temporary todo class, which is a bit dirty?

Sorry, could you tell me in more detail?
#30 - 2012-12-20 16:36 - Daniel Felix
Hi Toshi,

maybe there is a better way for displaying blocks.

Maybe some broken arrow or an dotted arrow? Those colors are nice, but you need to read those legend. If the arrow is selfexplaining, you haven't
the risk that the user could misunderstand the colors (maybe after holidays or some longer field trip ;-) ).

What do you think about this?

Best regards,
Daniel

#31 - 2012-12-28 05:27 - Toshi MARUYAMA
- File gantt-relations-r11086.png added
- File gantt-relations-r11086.diff added

Daniel Felix wrote:

Maybe some broken arrow or an dotted arrow?

Done.
# Display

+ Related issues
] r44; Rails 3 s
0] : testDO

d| Bug £51: testO1

This is a patch for trunk r11086.

#32 - 2013-01-04 12:05 - Daniel Felix
Hi Toshi,

this works still good in r11114.

Maybe this patch could be interessting for you #12730.
It also changes some parts of the gantt-modul. This could be combined with your new addition. Maybe both could be merged to trunk?

#33 - 2013-01-05 08:45 - Toshi MARUYAMA
- File ie7-issue-list.png added
Etienne Massip wrote:
Not sure the foreach syntax for (rel_type_key in ...) {} is supported by IE7/8?
| try this patch with IE7 on my Windows Vista.
This patch does not work.

Issue filter of trunk r11117 is broken on IE7.
| give up to run on IE7.

2025-07-02 5/7


https://www.redmine.org/projects/redmine/repository/svn/revisions/11086
https://www.redmine.org/projects/redmine/repository/svn/revisions/11114
https://www.redmine.org/issues/12730
https://www.redmine.org/projects/redmine/repository/svn/revisions/11117

ie7-issue-list.png

#34 - 2013-01-05 10:38 - Toshi MARUYAMA
- File ie8-gantt.png added
- File ie8-about.png added

| confirmed this patch works on IE8.
#35 - 2013-01-05 12:01 - Daniel Felix

Toshi MARUYAMA wrote:

| try this patch with IE7 on my Windows Vista.
This patch does not work.

Issue filter of trunk r11117 is broken on IE7.
| give up to run on IE7.

Hi Toshi,

| don't see this much critical. We could handle this as a graceful degradation. IE7 User won't have those relations. All newer Versions could handle it.
By the way, the IE 7 isn't supported by Microsoft anyway. This browser is going out of business. The most users will use a newer version of |E or
another browser like Firefox, Chrome, Opera and so on.

See: http://theie7countdown.com/

#36 - 2013-01-05 13:57 - Jean-Philippe Lang
- Status changed from New to Resolved

- Resolution set to Fixed

I've committed Toshi's patch with a few changes:

removed the option to show/hide the relations, they are now always displayed
moved the rendering options from the IssueRelation model to the gantt helper
optimized the loading of relations (a single query instead of 1 query per issue)
optimized the parsing of data on the client side

restored the solid lines (which | personnaly find much cleaner)

added a functional test

Toshi, thanks for your work on this great improvement!

#37 - 2013-01-05 14:05 - Daniel Felix

Thanks a lot for this implementation (Toshi and Jean-Philippe)!
This is realy helpful in bigger projects with much depencies!

#38 - 2013-01-05 20:59 - Yasaf Burshan

Hi all,

How do | use this update on a windows machine with 11S?

When | run the patch command I'm getting an error message saying that asking what file | would like to update.
Any help is appreciated.

Thanks.

#39 - 2013-01-05 21:17 - Daniel Felix
Yasaf Burshan wrote:
Hi all,
How do | use this update on a windows machine with 11S?
When | run the patch command I'm getting an error message saying that asking what file | would like to update.

Any help is appreciated.
Thanks.

Check your patch file. Maybe the path to the file in the patch is another than in your current trunnk (example: patch say /trunk/... and your local
repository starts with /redmine_trunk) or something like that.

You can also load a new version with the current trunk, which would be more stable than applying a single patch.
#40 - 2013-01-13 10:45 - Jean-Philippe Lang

- Status changed from Resolved to Closed
